unit UfrmExemploTList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Mask, Buttons;

type
  TfrmExemploTLista = class(TForm)
    btnCriaLista: TButton;
    btnAdicionaItem: TButton;
    btnContaItens: TButton;
    btnPercorreItens: TButton;
    btnTransfItens: TButton;
    lstbxItemsLista: TListBox;
    btnRemoveItem: TButton;
    edtIndice: TEdit;
    btnDestroiLista: TButton;
    cbxTipoItem: TComboBox;
    gbxManProps: TGroupBox;
    cbxClassName: TComboBox;
    lbClassName: TLabel;
    edtListIndex: TEdit;
    lbListIndex: TLabel;
    edtValor: TEdit;
    btnAplicar: TButton;
    lbCompName: TLabel;
    btnLerInformacoes: TBitBtn;
    lstInfoList: TListView;
    btnSearchComp: TButton;
    edtNamePesq: TEdit;
    procedure btnCriaListaClick(Sender: TObject);
    procedure btnAdicionaItemClick(Sender: TObject);
    procedure btnContaItensClick(Sender: TObject);
    procedure btnPercorreItensClick(Sender: TObject);
    procedure btnTransfItensClick(Sender: TObject);
    procedure btnRemoveItemClick(Sender: TObject);
    procedure edtIndiceKeyPress(Sender: TObject; var Key: Char);
    procedure btnDestroiListaClick(Sender: TObject);
    procedure btnAplicarClick(Sender: TObject);
    procedure btnLerInformacoesClick(Sender: TObject);
    procedure btnSearchCompClick(Sender: TObject);
  private
    { Private declarations }
    MyList : TList;
  public
    { Public declarations }
  end;
var
  frmExemploTLista: TfrmExemploTLista;

implementation

{$R *.dfm}

procedure TfrmExemploTLista.btnCriaListaClick(Sender: TObject);
begin
  MyList := TList.Create;
end;

procedure TfrmExemploTLista.btnAdicionaItemClick(Sender: TObject);
var
  pComp : TObject;
begin
  if MyList <> Nil then
     begin
       if cbxTipoItem.ItemIndex = 0 then
          pComp := TEdit.Create(Self)
       else
       if cbxTipoItem.ItemIndex = 1 then
          pComp := TCombobox.Create(Self)
       else
       if cbxTipoItem.ItemIndex = 2 then
          pComp := TButton.Create(Self);
       MyList.Add(pComp);
     end
  else
     Showmessage('A Lista ainda no foi criada');
end;

procedure TfrmExemploTLista.btnContaItensClick(Sender: TObject);
var
  i : Integer;
begin
  if MyList <> nil then
     begin
       i := MyList.Count;
       Showmessage('Existe(m) '+ IntToStr(I) + ' item(ns) na lista!');
     end;
end;

procedure TfrmExemploTLista.btnPercorreItensClick(Sender: TObject);
var
  I : Integer;
  pComp : TObject;
begin
  if MyList <> nil then
     begin
        for I := 0 to MyList.Count-1 do
          begin
            pComp := TObject(MyList.Items[I]);
            Showmessage(pComp.ClassName);
          end;
     end;
end;

procedure TfrmExemploTLista.btnTransfItensClick(Sender: TObject);
var
  I : Integer;
begin
  lstbxItemsLista.Clear; //Limpa o ListBox
  if MyList <> nil then
     begin
        for I := 0 to MyList.Count-1 do
          begin
            lstbxItemsLista.Items.Add(UpperCase(TObject(MyList.Items[I]).ClassName));
          end;
     end;
end;

procedure TfrmExemploTLista.btnRemoveItemClick(Sender: TObject);
var
  idx : Integer;
begin
  if MyList <> nil then
     begin
        idx := StrToInt(edtIndice.Text);
        if idx > MyList.Count-1 then
           Showmessage('O ndice informado no existe!')
        else
          begin
            MyList.Delete(idx);
            btnTransfItensClick(Sender);
            edtIndice.Clear;
          end;
     end;
end;

procedure TfrmExemploTLista.edtIndiceKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in ['0'..'9',#8]) then
     key := #0;
end;

procedure TfrmExemploTLista.btnDestroiListaClick(Sender: TObject);
var
  I : Integer;
begin
  if MyList <> nil then
     begin
       lstbxItemsLista.Clear;
       for I := 0 to MyList.Count-1 do
         begin
           TObject(MyList.Items[I]).Free;
         end;
       MyList.Free;
       MyList := nil;
     end;
end;

procedure TfrmExemploTLista.btnAplicarClick(Sender: TObject);
var
  pValor : String;
  idxList : Integer;
begin
  pValor := Trim(edtValor.Text);
  idxList := StrToInt(edtListIndex.Text);
  if MyList <> nil then
     begin
       if (UpperCase(TObject(MyList.Items[idxList]).ClassName) =
           UpperCase(cbxClassName.Text)) then
          begin
            TComponent(MyList.Items[idxList]).Name := pValor
          end
       else
          Showmessage('Os ndice informado no corresponde  classe informada!');
     end;
end;

procedure TfrmExemploTLista.btnLerInformacoesClick(Sender: TObject);
var
  i : integer;
  Item : TListItem;
begin
  lstInfoList.Clear;
  if MyList <> nil then
     begin
      for i := 0 to MyList.Count-1 do
        begin
          Item := lstInfoList.Items.Add;
          Item.Caption := TObject(MyList.Items[i]).ClassName;
          Item.SubItems.Add(TComponent(MyList.Items[i]).Name);
        end;
     end;
end;

procedure TfrmExemploTLista.btnSearchCompClick(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to MyList.Count-1 do
    begin
       if TComponent(MyList.Items[i]).Name = Trim(edtNamePesq.Text) then
          begin
            Showmessage('O objeto com este nome  um '+
                        TObject(MyList.Items[i]).ClassName +
                        ' E encontra-se no ndice '+ Inttostr(i)+
                        ' da lista');
          end;
    end;
end;

end.
